#!/bin/bash

umask 002

if [[ -z $Path_SICw ]]; then
  if ( [ -f /proc/sicread ] && [ -f /proc/sicregs ] ); then
    Path_SICw=/proc/sicread
    Path_SICr=/proc/sicregs
  elif  ( [ -f /proc/sicread ] && [ -f /proc/sicwrite ] ); then
    Path_SICw=/proc/sicread
    Path_SICr=/proc/sicread
  fi
  [[ ! -f $Path_SICw ]] && exit 1
fi

READ_ATTEMPT_NUMBER=20
get_reg() {
    local r
    local s
    local a
    local N=0
    local hex1=$(printf "0x%x" $1)
    while true; do
	((N++))
	echo ${hex1} > $Path_SICw
	s=`cat ${Path_SICr} | grep "node: $2 reg"`
	a=(`echo ${s,,} | awk '{print $4}' | tr '():' ' '`)
	if [[ $hex1 = ${a[0]} ]]; then
	    break
	fi
	if [[ -z ${a[0]} ]]; then
	    break
	fi
	if ((N>${READ_ATTEMPT_NUMBER})); then
	    break
	fi
	sleep .1
    done
    echo ${s}
}

#echo "0x0010" > $Path_SICw
#lcfg0_cpu[0]=`cat $Path_SICr | grep "node: 0 reg"`
#lcfg0_cpu[1]=`cat $Path_SICr | grep "node: 1 reg"`
#lcfg0_cpu[2]=`cat $Path_SICr | grep "node: 2 reg"`
#lcfg0_cpu[3]=`cat $Path_SICr | grep "node: 3 reg"`
lcfg0_cpu[0]=`get_reg "0x10" 0`
lcfg0_cpu[1]=`get_reg "0x10" 1`
lcfg0_cpu[2]=`get_reg "0x10" 2`
lcfg0_cpu[3]=`get_reg "0x10" 3`

nodes=""
for cpu in 0 1 2 3; do
	#lcfg0_value=`echo "${lcfg0_cpu[${cpu}]}" | awk '{print $5}'`
	#iol=$(( (${lcfg0_value} & 0x00000008) >> 3 ))
	n=$(printf "0x%x" `echo "${lcfg0_cpu[${cpu}]}" | awk '{print $5}'`)
	let "iol=( ($n & 0x8) >> 3 )"
	[[ "${iol}" == "1" ]] && nodes="${nodes} ${cpu}"
done

./iol_lite.sh ${nodes}
res=$?
[[ "$res" != "0" ]] && exit 1

./iol_reinit.sh ${nodes}
res=$?
[[ "$res" != "0" ]] && exit 1

./iol_lite.sh ${nodes}
res=$?
[[ "$res" != "0" ]] && exit 1

exit 0
